//  1991, Bowers Development Corp.
// UAMLibraryM.cp

#include "UAMLibraryM.h"
#ifndef __TYPES__
	#include <Types.h>
#endif
#ifndef __QUICKDRAW__
	#include <Quickdraw.h>
#endif
#ifndef __RESOURCES__
	#include <Resources.h>
#endif

const long kStdGrayLine			= 'Line';
const long kStdPalette			= 'Palt';
const long kStdPictButton		= 'pBut';
const long kStdPictCheckBox		= 'pChk';
const long kStdPictRadio		= 'pRad';
const long kStdMultiPict		= 'pMul';
const long kStdSlider			= 'Sldr';
const long kStdCustom			= 'Cust';


#pragma segment AMControlRes
/*----------*/
pascal void ActionProcForTSlider 	(ControlHandle		aCMgrControl,
								 	 short				partCode)
{
	TSlider		*aSlider;

	aSlider = (TSlider *) GetCRefCon (aCMgrControl);
	FailNIL (aSlider);

	aSlider->ActionProc (partCode);
} /* ActionProcForTSlider */


//-------------------------------------------------------
// TGrayLine (TView)		Gray line
//-------------------------------------------------------

#pragma segment ARes
/*----------*/
pascal void TGrayLine::Draw		(Rect		*area)
{	
	PenState		savePen;

	GetPenState (&savePen);
	PenNormal ();
	PenPat (qd.gray);

	MoveTo (area->left, area->top);
	LineTo (area->right - 1, area->bottom - 1);

	SetPenState (&savePen);
} /* Draw */

//-------------------------------------------------------
// TPalette (TCtlMgr)		Palette
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TPalette::IPalette  	(TView				*itsSuperView,
									 VPoint				*itsLocation, 
								 	 VPoint 			*itsSize,
									 SizeDeterminer		itsHSizeDet, 
									 SizeDeterminer		itsVSizeDet,
									 short				itsPictureID,
									 short				itsNumberAcross,
									 short				itsNumberDown,
									 short				itsFrameSize)	
{
	Str255		itsLabel;

	itsLabel [0] = 4;
	itsLabel [1] = (Byte) (itsPictureID >> 8);
	itsLabel [2] = (Byte) (itsPictureID & 0x00FF);
	itsLabel [3] = (Byte) itsNumberAcross;
	itsLabel [4] = (Byte) itsNumberDown;

	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsLabel, 
				1, 1, (itsNumberAcross * itsNumberDown), 
				(kPaletteProcID + itsFrameSize));
	fDefChoice = mPaletteHit;
} /* IPalette */

#pragma segment AInit
/*----------*/
pascal void TPalette::IRes 		(TDocument		*itsDocument,
								 TView			*itsSuperView,
								 Ptr			*itsParams) 				
{
	Rect			itsArea;
	Str255			itsLabel;
	PaletteTPtr		ptPtr;

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mPaletteHit;
	ControlArea (&itsArea);
	ptPtr = (PaletteTPtr) *itsParams;
	itsLabel [0] = 4;
	itsLabel [1] = (Byte) (ptPtr->itsPictureID >> 8);
	itsLabel [2] = (Byte) (ptPtr->itsPictureID & 0x00FF);
	itsLabel [3] = (Byte) ptPtr->itsNumberAcross;
	itsLabel [4] = (Byte) ptPtr->itsNumberDown;
	CreateCMgrControl (&itsArea, itsLabel, 1, 1, 
							(ptPtr->itsNumberDown * ptPtr->itsNumberAcross), 
							(kPaletteProcID + ptPtr->itsFrameSize));
	
	OffsetPtr ((long *)itsParams, sizeof (PaletteTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TPalette::WRes		(ViewRsrcHndl	theResource,
								 Ptr			*itsParams) 
{
	Str255			theLabel;
	PaletteTPtr		ptPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr = (PaletteTPtr) (ExpandPtr (theResource, (long *)itsParams,
								sizeof (PaletteTemplate)) );
	ptPtr->itsPictureID = (short) ((theLabel [1] << 8) + theLabel [2]);
	ptPtr->itsNumberAcross = (short) theLabel [3];
	ptPtr->itsNumberDown = (short) theLabel [4];
	ptPtr->itsFrameSize = GetCVariant (fCMgrControl);

} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TPalette::WriteRes	  	(ViewRsrcHndl	theResource,
									 Ptr			*itsParams)
{
	gWResSignature = kStdPalette; 
	CopyStr255 ("\pTPalette", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment AFields
/*----------*/
pascal void TPalette::Fields	(pascal void (*DoToField)
										(StringPtr		fieldName, 
										 Ptr			fieldAddr, 
										 short			fieldType, 
										 void			*DoToField_StaticLink),
								 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTPalette", NULL, bClass, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TPictButton (TCtlMgr)		Picture button
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TPictButton::IPictButton   (TView			*itsSuperView,
										VPoint			*itsLocation, 
										VPoint 			*itsSize,
										SizeDeterminer	itsHSizeDet, 
										SizeDeterminer	itsVSizeDet,
										StringPtr		itsPicts)	
{
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, 
				0, 0, 1, kPictButtonProcID);
	fDefChoice = mButtonHit;
} /* IPictButton */

#pragma segment AInit
/*----------*/
pascal void TPictButton::IRes 		(TDocument		*itsDocument,
									 TView			*itsSuperView,
									 Ptr			*itsParams)
{
	Rect				itsArea;
	PictControlTPtr		ptPtr;

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mButtonHit;
	ControlArea (&itsArea);
	ptPtr = (PictControlTPtr) *itsParams;
	CreateCMgrControl (&itsArea, ptPtr->itsPictureIDs, 
							0, 0, 1, kPictButtonProcID);
	
	OffsetPtrWStr ((long *)itsParams, sizeof (PictControlTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictButton::WRes		(ViewRsrcHndl	theResource,
									 Ptr			*itsParams) 
{ 
	Str255				theLabel;
	PictControlTPtr		ptPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr = (PictControlTPtr) (ExpandPtrWStr (theResource, (long *)itsParams, 
									sizeof (PictControlTemplate), theLabel [0]));
	CopyStr255 (theLabel, PRStr (ptPtr->itsPictureIDs));
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictButton::WriteRes	 (ViewRsrcHndl	theResource,
									  Ptr			*itsParams)
{
	gWResSignature = kStdPictButton; 
	CopyStr255 ("\pTPictButton", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment AFields
/*----------*/
pascal void TPictButton::Fields		(pascal void (*DoToField)
											(StringPtr		fieldName, 
											 Ptr			fieldAddr, 
											 short			fieldType, 
											 void			*DoToField_StaticLink),
									 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTPictButton", NULL, bClass, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TPictCheckBox (TCtlMgr)	Picture check box
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TPictCheckBox::IPictCheckBox   (TView			*itsSuperView,
											VPoint			*itsLocation, 
											VPoint 			*itsSize,
											SizeDeterminer	itsHSizeDet, 
											SizeDeterminer	itsVSizeDet,
											StringPtr		itsPicts,
											Boolean			isTurnedOn)
	
{
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, 
				0, 0, 1, kPictCheckProcID);
	SetState (isTurnedOn, kDontRedraw);
	fDefChoice = mCheckBoxHit;
} /* IPictCheckBox */

#pragma segment AInit
/*----------*/
pascal void TPictCheckBox::IRes 	   (TDocument		*itsDocument,
										TView			*itsSuperView,
										Ptr				*itsParams)				
{
	Rect				itsArea;
	PictControlTPtr		ptPtr;

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mCheckBoxHit;
	ControlArea (&itsArea);
	ptPtr = (PictControlTPtr) *itsParams;
	CreateCMgrControl (&itsArea, ptPtr->itsPictureIDs, 
							0, 0, 1, kPictCheckProcID); 

	OffsetPtrWStr ((long *)itsParams, sizeof (PictControlTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictCheckBox::WRes		   (ViewRsrcHndl	theResource,
										Ptr				*itsParams) 				
{
	Str255				theLabel;
	PictControlTPtr		ptPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr = (PictControlTPtr) (ExpandPtrWStr (theResource, (long *)itsParams, 
									sizeof (PictControlTemplate), theLabel [0]));
	CopyStr255 (theLabel, PRStr (ptPtr->itsPictureIDs));
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictCheckBox::WriteRes	   (ViewRsrcHndl	theResource,
										Ptr				*itsParams) 				
{
	gWResSignature = kStdPictCheckBox; 
	CopyStr255 ("\pTPictCheckBox", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment ARes
/*----------*/
pascal void TPictCheckBox::DoChoice	   (TView			*origView,
										short			itsChoice)			
{
	if (itsChoice == mCheckBoxHit) {
		Toggle (kRedraw);
	}
	inherited::DoChoice (origView, itsChoice);
} /* DoChoice */

#pragma segment ARes
/*----------*/
pascal Boolean  TPictCheckBox::IsOn    (void)
{
	if (GetLongVal () != 0) {
		return (TRUE);
	} else {
		return (FALSE);
	}
} /* IsOn */

#pragma segment ARes
/*----------*/
pascal void TPictCheckBox::SetState	   (Boolean			state,
										Boolean			redraw)
{
	SetLongVal (state, redraw);
} /* SetState */

#pragma segment ARes
/*----------*/
pascal void TPictCheckBox::Toggle	   (Boolean			redraw)
{
	SetLongVal (!IsOn (), redraw);
} /* Toggle */

#pragma segment ARes
/*----------*/
pascal void TPictCheckBox::ToggleIf	   (Boolean			matchState,
										Boolean			redraw)
{
	if (IsOn () == matchState) {
		SetLongVal (!IsOn (), redraw);
	}
} /* ToggleIf */

#pragma segment AFields
/*----------*/
pascal void TPictCheckBox::Fields	(pascal void (*DoToField)
											(StringPtr		fieldName, 
											 Ptr			fieldAddr, 
											 short			fieldType, 
											 void			*DoToField_StaticLink),
									 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTPictCheckBox", NULL, bClass, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TPictRadio (TCtlMgr)		Picture radio button
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TPictRadio::IPictRadio	   (TView			*itsSuperView,
										VPoint			*itsLocation, 
										VPoint 			*itsSize,
										SizeDeterminer	itsHSizeDet, 
										SizeDeterminer	itsVSizeDet,
										StringPtr		itsPicts,
										Boolean			isTurnedOn)	
{
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, 
				0, 0, 1, kPictRadioProcID);
	SetState (isTurnedOn, kDontRedraw);
	fDefChoice = mRadioHit;
} /* IPictRadio */

#pragma segment AInit
/*----------*/
pascal void TPictRadio::IRes 	(TDocument		*itsDocument,
								 TView			*itsSuperView,
								 Ptr			*itsParams)				
{
	Rect				itsArea;
	PictControlTPtr		ptPtr;

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mRadioHit;
	ControlArea (&itsArea);
	ptPtr = (PictControlTPtr) *itsParams;
	CreateCMgrControl (&itsArea, ptPtr->itsPictureIDs, 
 							0, 0, 1, kPictRadioProcID); 

	OffsetPtrWStr ((long *)itsParams, sizeof (PictControlTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictRadio::WRes	(ViewRsrcHndl	theResource,
								 Ptr			*itsParams) 				
{
	Str255				theLabel;
	PictControlTPtr		ptPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr = (PictControlTPtr) (ExpandPtrWStr (theResource, (long *)itsParams, 
									sizeof (PictControlTemplate), theLabel [0]));
	CopyStr255 (theLabel, PRStr (ptPtr->itsPictureIDs));
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TPictRadio::WriteRes	(ViewRsrcHndl	theResource,
									 Ptr			*itsParams) 				
{
	gWResSignature = kStdPictRadio; 
	CopyStr255 ("\pTPictRadio", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment ARes
/*----------*/
pascal void TPictRadio::DoChoice	(TView			*origView,
									 short			itsChoice)			
{
	if ((itsChoice == mRadioHit) && !IsOn ()) {
		Toggle (kRedraw);
	}
	inherited::DoChoice (origView, itsChoice);
} /* DoChoice */

#pragma segment ARes
/*----------*/
pascal Boolean  TPictRadio::IsOn 	(void)
{
	if (GetLongVal () != 0) {
		return (TRUE);
	} else {
		return (FALSE);
	}
} /* IsOn */

#pragma segment ARes
/*----------*/
pascal void TPictRadio::SetState	(Boolean			state,
									 Boolean			redraw)
{
	SetLongVal (state, redraw);
} /* SetState */

#pragma segment ARes}
/*----------*/
pascal void TPictRadio::Toggle		(Boolean			redraw)
{
	SetLongVal (!IsOn (), redraw);
} /* Toggle */

#pragma segment ARes
/*----------*/
pascal void TPictRadio::ToggleIf	(Boolean			matchState,
									 Boolean			redraw)
{
	if (IsOn () == matchState) {
		SetLongVal (!IsOn (), redraw);
	}
} /* ToggleIf */

#pragma segment AFields
/*----------*/
pascal void TPictRadio::Fields	 	(pascal void (*DoToField)
											(StringPtr		fieldName, 
											 Ptr			fieldAddr, 
											 short			fieldType, 
											 void			*DoToField_StaticLink),
									 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTPictRadio", NULL, bClass, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TMultiPict (TCtlMgr)		Multi-picture control
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TMultiPict::IMultiPict		(TView				*itsSuperView,
										 VPoint				*itsLocation, 
										 VPoint 			*itsSize,
										 SizeDeterminer		itsHSizeDet, 
										 SizeDeterminer		itsVSizeDet,
										 StringPtr			itsPicts,
										 short				curValue)	
{
	short		numberOfPicts;		// number of possible states for the control

	numberOfPicts = itsPicts [0] / 2;	// 2 bytes for each picture ID
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, 
				1, 1, numberOfPicts, kMultiPictProcID);
	SetVal (curValue, kDontRedraw);
	fDefChoice = mMultiPictHit;
} /* IMultiPict */

#pragma segment AInit
/*----------*/
pascal void TMultiPict::IRes 	(TDocument		*itsDocument,
								 TView			*itsSuperView,
								 Ptr			*itsParams)				
{
	Rect				itsArea;
	PictControlTPtr		ptPtr;
	short				numberOfPicts;		// number of possible states for the control

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mMultiPictHit;
	ControlArea (&itsArea);
	ptPtr = (PictControlTPtr) *itsParams;
	numberOfPicts = (ptPtr->itsPictureIDs [0]) / 2;		// 2 bytes for each picture ID
	CreateCMgrControl (&itsArea, ptPtr->itsPictureIDs, 
 							1, 1, numberOfPicts, kMultiPictProcID); 

	OffsetPtrWStr ((long *)itsParams, sizeof (PictControlTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TMultiPict::WRes	(ViewRsrcHndl	theResource,
								 Ptr			*itsParams) 				
{
	Str255				theLabel;
	PictControlTPtr		ptPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr = (PictControlTPtr) (ExpandPtrWStr (theResource, (long *)itsParams, 
									sizeof (PictControlTemplate), theLabel [0]));
	CopyStr255 (theLabel, PRStr (ptPtr->itsPictureIDs));
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TMultiPict::WriteRes	(ViewRsrcHndl	theResource,
									 Ptr			*itsParams) 				
{
	gWResSignature = kStdMultiPict; 
	CopyStr255 ("\pTMultiPict", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment ARes
/*----------*/
pascal void TMultiPict::DoChoice	(TView		*origView,
									 short		itsChoice)			
{
	if (itsChoice == mMultiPictHit) {
		Cycle (kRedraw);
	}
	inherited::DoChoice (origView, itsChoice);
} /* DoChoice */

#pragma segment ARes
/*----------*/
pascal void TMultiPict::Cycle	(Boolean		redraw)
{
	short		curVal;

	curVal = GetVal ();

	if (curVal == GetMax ()) {
		curVal = GetMin ();
	} else {
		curVal++;
	}
	SetVal (curVal, redraw);
} /* Cycle */

#pragma segment AFields
/*----------*/
pascal void TMultiPict::Fields		(pascal void (*DoToField)
											(StringPtr		fieldName, 
											 Ptr			fieldAddr, 
											 short			fieldType, 
											 void			*DoToField_StaticLink),
									 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTMultiPict", NULL, bClass, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TSlider (TCtlMgr)		Custom slider
//-------------------------------------------------------

#pragma segment AOpen
/*----------*/
pascal void TSlider::ISlider	(TView			*itsSuperView,
								 VPoint			*itsLocation, 
								 VPoint 		*itsSize,
								 SizeDeterminer	itsHSizeDet, 
								 SizeDeterminer	itsVSizeDet,
								 VHSelect		itsDirection,
								 StringPtr		itsPicts,
								 short			itsProcID,
								 long			itsVal,
								 long			itsMin,
								 long			itsMax)	
{
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, itsVal, itsMin, itsMax, itsProcID);
	fDirection = itsDirection;
	fDefChoice = mSliderHit;
} /* ISlider */

#pragma segment AInit
/*----------*/
pascal void TSlider::IRes 	(TDocument		*itsDocument,
							 TView			*itsSuperView,
							 Ptr			*itsParams)				
{
	Rect			itsArea;
	SliderTPtr		stPtr;

	inherited::IRes (itsDocument, itsSuperView, itsParams);
	
	fDefChoice = mSliderHit;
	ControlArea (&itsArea);
	stPtr = (SliderTPtr) *itsParams;
	CreateCMgrControl (&itsArea, stPtr->itsPictureIDs,
							0, 0, 10, kSliderProcID + stPtr->itsVariantCode);

	if ((itsArea.bottom - itsArea.top)
	>=  (itsArea.right - itsArea.left)) {
		fDirection = v;
	} else {
		fDirection = h;
	}

	OffsetPtrWStr ((long *)itsParams, sizeof (SliderTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TSlider::WRes		(ViewRsrcHndl	theResource,
								 Ptr			*itsParams)				
{
	Str255			theLabel;
	SliderTPtr		stPtr;

	inherited::WRes (theResource, itsParams);	
	
	GetText (theLabel);
	stPtr = (SliderTPtr) (ExpandPtrWStr (theResource, (long *)itsParams, 
									sizeof (SliderTemplate), theLabel [0]));
	stPtr->itsVariantCode = 0;	// should be control's variant code
	CopyStr255 (theLabel, PRStr (stPtr->itsPictureIDs));
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TSlider::WriteRes	(ViewRsrcHndl	theResource,
								 Ptr			*itsParams) 				
{
	gWResSignature = kStdSlider; 
	CopyStr255 ("\pTSlider", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment ARes
/*----------*/
pascal void TSlider::DeltaValue	  	(VCoordinate		delta)
{
	if (delta != 0) {
		if (delta > 0) {
			delta = Min (delta, fLongMax - fLongVal);
		} else {
			delta = Max (delta, fLongMin - fLongVal);
		}

		SetLongVal (fLongVal + delta, TRUE);
	}
} /* DeltaValue */

#pragma segment ASelCommand
/*----------*/
pascal TCommand* TSlider::DoMouseCommand 	(Point		*theMouse, 
											 EventInfo  *	/* info */, 
											 Point 		*	/* hysteresis */)
{
	short			partCode;
	VCoordinate		oldLongValue;
	VCoordinate		newLongValue;

#if qDebug
		AssumeFocused ();
#endif
	
	oldLongValue = fLongVal;
	partCode = TestControl (fCMgrControl, *theMouse);
	
	switch (partCode) {
		case inUpButton:
		case inDownButton: 
		case inPageUp:
		case inPageDown:	
				partCode = TrackControl (fCMgrControl, *theMouse, (ProcPtr)&ActionProcForTSlider);
				if (fLongVal != oldLongValue) {
					DoChoice (this, fDefChoice);
				}
			break;
		case inThumb:
				if (TrackControl (fCMgrControl, *theMouse, NULL) == inThumb) {
					if (GetVal () == GetMax ()) {
						newLongValue = fLongMax;
					} else {
						newLongValue = ((long) GetVal () << fBitsToShift);
					}
					SetLongVal(newLongValue, kRedraw);
				}

				if (fLongVal != oldLongValue) {
					DoChoice (this, fDefChoice);
				}
			break;
		default:
			break;
	} /* switch */
	
	return (NULL);
} /* DoMouseCommand */

#pragma segment ARes
/*----------*/
pascal void TSlider::TrackSlider	(short		/* partCode */)
{
	DeltaValue (1);		// only one part code
} /* TrackSlider */

#pragma segment ASelCommand
/*----------*/
/* this is based on TScrollBar.ActionProc.  I'm not completely sure it's right */
pascal void TSlider::ActionProc			(short		partCode)
{
	if (partCode != 0) {
		TrackSlider (partCode);		// bounds checking?
	}
	Update ();
	if (Focus ()) {
	}
} /* ActionProc */

#pragma segment AFields
/*----------*/
pascal void TSlider::Fields		(pascal void (*DoToField)
										(StringPtr		fieldName, 
										 Ptr			fieldAddr, 
										 short			fieldType, 
										 void			*DoToField_StaticLink),
								 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTSlider", NULL, bClass, DoToField_StaticLink);
	(*DoToField) ("\pfDirection", (Ptr)&fDirection, bVHSelect, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

//-------------------------------------------------------
// TCustomCntl (TCtlMgr)		Other custom control
//-------------------------------------------------------

struct CntlTemplate {
	Rect 		boundsRect;
	short		value;
	Boolean		visible;
	Boolean		filler1;
	short		max;
	short		min;
	short		procID;
	long		refCon;
	Str255		title;
}; 
typedef CntlTemplate *ControlTPtr, **ControlTHndl;

#pragma segment AOpen
/*----------*/
pascal void TCustomCntl::ICustom 	(TView				*itsSuperView,
									 VPoint				*itsLocation, 
									 VPoint 			*itsSize,
									 SizeDeterminer		itsHSizeDet, 
									 SizeDeterminer		itsVSizeDet,
									 short				itsCntlID)	
{
	ControlTHndl	itsCNTL;
	short			min;
	short			max;

	fCntlID = itsCntlID;
	itsCNTL = (ControlTHndl) Get1Resource ('CNTL', itsCntlID);
	LoadResource ((Handle) itsCNTL);
	HLock ((Handle) itsCNTL);
	min	= (**itsCNTL).min;
	max = (**itsCNTL).max;
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, (**itsCNTL).title, 
				min, min, max, (**itsCNTL).procID);
	ReleaseResource ((Handle) itsCNTL);
	fDefChoice = mCustomHit;
} /* ICustom */

#pragma segment AInit
/*----------*/
pascal void TCustomCntl::IRes	(TDocument		*itsDocument,
								 TView			*itsSuperView,
								 Ptr			*itsParams)
{
	Rect				itsArea;
	CustomControlTPtr	ctPtr;
	ControlTHndl		itsCNTL;
	short				min;
	short				max;

	inherited::IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice = mCustomHit;
	ControlArea (&itsArea);
	ctPtr = (CustomControlTPtr) *itsParams;
	fCntlID = ctPtr->itsCntlID;
	itsCNTL = (ControlTHndl) Get1Resource ('CNTL', ctPtr->itsCntlID);
	LoadResource ((Handle) itsCNTL);
	HLock ((Handle) itsCNTL);
	min	= (**itsCNTL).min;
	max = (**itsCNTL).max;
	CreateCMgrControl (&itsArea, (**itsCNTL).title, min, min, max, (**itsCNTL).procID); 
	ReleaseResource ((Handle) itsCNTL);

	OffsetPtr ((long *)itsParams, sizeof (CustomControlTemplate));
} /* IRes */

#pragma segment WriteRes
/*----------*/
pascal void TCustomCntl::WRes	(ViewRsrcHndl	theResource,
								 Ptr			*itsParams) 
{
	Str255				theLabel;
	CustomControlTPtr	ctPtr;

	inherited::WRes (theResource, itsParams);	
	
	ctPtr = (CustomControlTPtr) (ExpandPtr (theResource, (long *)itsParams, 
									sizeof (CustomControlTemplate)) );
	ctPtr->itsCntlID = fCntlID;
} /* WRes */

#pragma segment WriteRes
/*----------*/
pascal void TCustomCntl::WriteRes	(ViewRsrcHndl	theResource,
									 Ptr			*itsParams)
{
	gWResSignature = kStdCustom; 
	CopyStr255 ("\pTCustomCntl", gWResType);
	WRes (theResource, itsParams);
} /* WriteRes */

#pragma segment AFields
/*----------*/
pascal void TCustomCntl::Fields		(pascal void (*DoToField)
											(StringPtr		fieldName, 
											 Ptr			fieldAddr, 
											 short			fieldType, 
											 void			*DoToField_StaticLink),
									 void	*DoToField_StaticLink)
{
	(*DoToField) ("\pTCustomCntl", NULL, bClass, DoToField_StaticLink);
	(*DoToField) ("\pfCntlID", (Ptr)&fCntlID, bInteger, DoToField_StaticLink);
	inherited::Fields (DoToField, DoToField_StaticLink);
} /* Fields */

/* UAMLibrary.cp */
