{  1991, Bowers Development Corp. }
{ UAMLibraryM.p }

const
	kStdGrayLine		= 'Line';
	kStdPalette			= 'Palt';
	kStdPictButton		= 'pBut';
	kStdPictCheckBox	= 'pChk';
	kStdPictRadio		= 'pRad';
	kStdMultiPict		= 'pMul';
	kStdSlider			= 'Sldr';
	kStdCustom			= 'Cust';

{$S AMControlRes}
{----------}
Procedure ActionProcForTSlider	(aCMgrControl:	ControlHandle;
								 partCode:		integer);
var
	aSlider: 		TSlider;
Begin
	aSlider := TSlider (GetCRefCon (aCMgrControl));
	FailNil (aSlider);

	aSlider.ActionProc (partCode);
End; {ActionProcForTSlider}

{$S ARes}
{-------------------------------------------------------}
{ TGrayLine (TView)			Gray line					}
{-------------------------------------------------------}

{----------}
Procedure TGrayLine.Draw		(area:			Rect);
var
	savePen: PenState;
Begin	
	GetPenState (savePen);
	PenNormal;
	PenPat (gray);

	MoveTo (area.left, area.top);
	LineTo (area.right - 1, area.bottom - 1);

	SetPenState (savePen);
End; {Draw}

{-------------------------------------------------------}
{ TPalette (TCtlMgr)		Palette						}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TPalette.IPalette  	(itsSuperView:	 	TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet: 		SizeDeterminer; 
								 itsVSizeDet: 		SizeDeterminer;
								 itsPictureID:		integer;
								 itsNumberAcross:	integer;
								 itsNumberDown:		integer;
								 itsFrameSize:		integer);	
var
	itsLabel:		Str255;
Begin
	itsLabel [0] := chr (4);
	itsLabel [1] := chr (BSR (itsPictureID, 8));
	itsLabel [2] := chr (BAnd (itsPictureID, $FF));
	itsLabel [3] := chr (itsNumberAcross);
	itsLabel [4] := chr (itsNumberDown);
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
					 itsHSizeDet, itsVSizeDet, itsLabel, 
					 1, 1, (itsNumberAcross * itsNumberDown), 
					 (kPaletteProcID + itsFrameSize));
	fDefChoice := mPaletteHit;
End; {IPictButton}

{$S AInit}
{----------}
Procedure TPalette.IRes 	(itsDocument:	TDocument;
							 itsSuperView: 	TView;
						 var itsParams: 	Ptr);
var
	itsArea:		Rect;
	itsLabel:		Str255;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mPaletteHit;
	ControlArea (itsArea);
	with PaletteTPtr (itsParams)^ do begin
		itsLabel [0] := chr (4);
		itsLabel [1] := chr (BSR (itsPictureID, 8));
		itsLabel [2] := chr (BAnd (itsPictureID, $FF));
		itsLabel [3] := chr (itsNumberAcross);
		itsLabel [4] := chr (itsNumberDown);
		CreateCMgrControl (itsArea, itsLabel, 1, 1, 
							(itsNumberDown * itsNumberAcross), 
							(kPaletteProcID + ItsFrameSize));
	end; {with}
	
	OffsetPtr (itsParams, sizeof (PaletteTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TPalette.WRes		  	(theResource:	ViewRsrcHndl;
						  	 var itsParams:		Ptr); 
var
	theLabel:	Str255;
	ptPtr:		PaletteTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr := PaletteTPtr (ExpandPtr (theResource, itsParams, 
									sizeof (PaletteTemplate)));
	with ptPtr^ do begin
		itsPictureID := BOr (BSL (ord (theLabel [1]), 8), ord (theLabel [2]));
		itsNumberAcross := ord (theLabel [3]);
		itsNumberDown := ord (theLabel [4]);
		itsFrameSize := GetCVariant (fCMgrControl);
	end; {with}
End; {WRes}

{$S WriteRes}
{----------}
Procedure TPalette.WriteRes	  	(theResource:	ViewRsrcHndl;
			   				 var itsParams:		Ptr);
Begin
	gWResSignature := kStdPalette; 
	gWResType := 'TPalette';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S AFields}
{----------}
Procedure TPalette.Fields	(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
							);
Begin
	DoToField ('TPalette', nil, bClass);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TPictButton (TCtlMgr)		Picture button				}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TPictButton.IPictButton	(itsSuperView: 	TView;
									 itsLocation: 	VPoint; 
									 itsSize: 		VPoint;
									 itsHSizeDet: 	SizeDeterminer; 
									 itsVSizeDet: 	SizeDeterminer;
									 itsPicts:		Str255);	
Begin
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
				itsHSizeDet, itsVSizeDet, itsPicts, 
				0, 0, 1, kPictButtonProcID);
	fDefChoice := mButtonHit;
End; {IPictButton}

{$S AInit}
{----------}
Procedure TPictButton.IRes 		(itsDocument:		TDocument;
								 itsSuperView: 		TView;
							 var itsParams: 		Ptr);
var
	itsArea:		Rect;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mButtonHit;
	ControlArea (itsArea);
	with PictControlTPtr (itsParams)^ do begin
		CreateCMgrControl (itsArea, itsPictureIDs, 0, 0, 1, kPictButtonProcID);
	end; {with}
	
	OffsetPtrWStr (itsParams, sizeof (PictControlTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TPictButton.WRes		  (theResource:		ViewRsrcHndl;
							   var itsParams:		Ptr); 
var
	theLabel:	Str255;
	ptPtr:		PictControlTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr := PictControlTPtr (ExpandPtrWStr (theResource, itsParams, 
									sizeof (PictControlTemplate), Length (theLabel)));
	CopyStr255 (theLabel, PRStr (ptPtr^.itsPictureIDs));
End; {WRes}

{$S WriteRes}
{----------}
Procedure TPictButton.WriteRes	  (theResource:		ViewRsrcHndl;
			   				   var itsParams:		Ptr);
Begin
	gWResSignature := kStdPictButton; 
	gWResType := 'TPictButton';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S AFields}
{----------}
Procedure TPictButton.Fields	(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
							);
Begin
	DoToField ('TPictButton', nil, bClass);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TPictCheckBox (TCtlMgr)	Picture check box			}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TPictCheckBox.IPictCheckBox    (itsSuperView: 	TView;
										  itsLocation: 		VPoint; 
										  itsSize: 			VPoint;
										  itsHSizeDet: 		SizeDeterminer; 
										  itsVSizeDet: 		SizeDeterminer;
										  itsPicts:			Str255;
							  			  isTurnedOn: 		Boolean);
	
Begin
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
					itsHSizeDet, itsVSizeDet, itsPicts, 
					0, 0, 1, kPictCheckProcID);
	SetState (isTurnedOn, kDontRedraw);
	fDefChoice := mCheckBoxHit;
End; {IPictCheckBox}

{$S AInit}
{----------}
Procedure TPictCheckBox.IRes 	(itsDocument:		TDocument;
								 itsSuperView: 		TView;
							 var itsParams: 		Ptr);				
var
	itsArea:			Rect;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mCheckBoxHit;
	ControlArea (itsArea);
	with PictControlTPtr (itsParams)^ do begin
		CreateCMgrControl (itsArea, itsPictureIDs, 0, 0, 1, kPictCheckProcID); 
	end; {with}

	OffsetPtrWStr (itsParams, sizeof (PictControlTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TPictCheckBox.WRes	(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 				
var
	theLabel:	Str255;
	ptPtr:		PictControlTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr := PictControlTPtr (ExpandPtrWStr (theResource, itsParams, 
									sizeof (PictControlTemplate), Length (theLabel)));
	CopyStr255 (theLabel, PRStr (ptPtr^.itsPictureIDs));
End; {WRes}

{$S WriteRes}
{----------}
Procedure TPictCheckBox.WriteRes		(theResource:		ViewRsrcHndl;
									 var itsParams:			Ptr); 				
Begin
	gWResSignature := kStdPictCheckBox; 
	gWResType := 'TPictCheckBox';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S ARes}
{----------}
Procedure TPictCheckBox.DoChoice	(origView:			TView;
									 itsChoice:			integer);			
Begin
	if itsChoice = mCheckBoxHit then begin
		Toggle (kRedraw);
	end;
	inherited DoChoice (origView, itsChoice);
End; {DoChoice}

{$S ARes}
{----------}
Function  TPictCheckBox.IsOn: Boolean;
Begin
	IsOn := (GetLongVal <> 0);
End; {IsOn}

{$S ARes}
{----------}
Procedure TPictCheckBox.SetState	(state:				Boolean;
									 redraw:			Boolean);
Begin
	SetLongVal (ord (state), redraw);
End; {SetState}

{$S ARes}
{----------}
Procedure TPictCheckBox.Toggle		(redraw:			Boolean);
Begin
	SetLongVal (ord (not IsOn), redraw);
End; {Toggle}

{$S ARes}
{----------}
Procedure TPictCheckBox.ToggleIf	(matchState:		Boolean;
									 redraw:			Boolean);
Begin
	if IsOn = matchState then begin
		SetLongVal (ord (not IsOn), redraw);
	end;
End; {ToggleIf}

{$S AFields}
{----------}
Procedure TPictCheckBox.Fields	(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);
Begin
	DoToField ('TPictCheckBox', nil, bClass);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TPictRadio (TCtlMgr)		Picture radio button		}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TPictRadio.IPictRadio	   	(itsSuperView: 		TView;
									 itsLocation: 		VPoint; 
									 itsSize: 			VPoint;
									 itsHSizeDet: 		SizeDeterminer; 
									 itsVSizeDet: 		SizeDeterminer;
									 itsPicts:			Str255;
									 isTurnedOn:		Boolean);	
Begin
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
					itsHSizeDet, itsVSizeDet, itsPicts, 
					 0, 0, 1, kPictRadioProcID);
	SetState (isTurnedOn, kDontRedraw);
	fDefChoice := mRadioHit;
End; {IPictRadio}

{$S AInit}
{----------}
Procedure TPictRadio.IRes 		(itsDocument:		TDocument;
								 itsSuperView: 		TView;
							 var itsParams: 		Ptr);				
var
	itsArea:		Rect;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mRadioHit;
	ControlArea (itsArea);
	with PictControlTPtr (itsParams)^ do begin
		CreateCMgrControl (itsArea, itsPictureIDs, 0, 0, 1, kPictCheckProcID); 
	end; {with}

	OffsetPtrWStr (itsParams, sizeof (PictControlTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TPictRadio.WRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 				
var
	theLabel:	Str255;
	ptPtr:		PictControlTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr := PictControlTPtr (ExpandPtrWStr (theResource, itsParams, 
									sizeof (PictControlTemplate), Length (theLabel)));
	CopyStr255 (theLabel, PRStr (ptPtr^.itsPictureIDs));
End; {WRes}

{$S WriteRes}
{----------}
Procedure TPictRadio.WriteRes		(theResource:		ViewRsrcHndl;
								 var itsParams:			Ptr); 				
Begin
	gWResSignature := kStdPictRadio; 
	gWResType := 'TPictRadio';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S ARes}
{----------}
Procedure TPictRadio.DoChoice		(origView:			TView;
									 itsChoice:			integer);			
Begin
	if (itsChoice = mRadioHit) & (not IsOn) then begin
		Toggle (kRedraw);
	end;
	inherited DoChoice (origView, itsChoice);
End; {DoChoice}

{$S ARes}
{----------}
Function  TPictRadio.IsOn: Boolean;
Begin
	IsOn := (GetLongVal <> 0);
End; {IsOn}

{$S ARes}
{----------}
Procedure TPictRadio.SetState		(state:				Boolean;
									 redraw:			Boolean);
Begin
	SetLongVal (ord (state), redraw);
End; {SetState}

{$S ARes}
{----------}
Procedure TPictRadio.Toggle			(redraw:			Boolean);
Begin
	SetLongVal (ord (not IsOn), redraw);
End; {Toggle}

{$S ARes}
{----------}
Procedure TPictRadio.ToggleIf		(matchState:		Boolean;
									 redraw:			Boolean);
Begin
	if IsOn = matchState then begin
		SetLongVal (ord (not IsOn), redraw);
	end;
End; {ToggleIf}

{$S AFields}
{----------}
Procedure TPictRadio.Fields		(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);
Begin
	DoToField ('TPictRadio', nil, bClass);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TMultiPict (TCtlMgr)		Multi-picture control		}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TMultiPict.IMultiPict		(itsSuperView: 		TView;
									 itsLocation: 		VPoint; 
									 itsSize: 			VPoint;
									 itsHSizeDet: 		SizeDeterminer; 
									 itsVSizeDet: 		SizeDeterminer;
									 itsPicts:			Str255;
									 curValue:			integer);	
var
	numberOfPicts:		integer;		{ number of possible states for the control }
Begin
	numberOfPicts := (length (itsPicts)) div 2;	{ 2 bytes for each picture ID }
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
					itsHSizeDet, itsVSizeDet, itsPicts, 
					curValue, 1, numberOfPicts, kMultiPictProcID);
	fDefChoice := mMultiPictHit;
End; {IPictRadio}

{$S AInit}
{----------}
Procedure TMultiPict.IRes 		(itsDocument:		TDocument;
								itsSuperView: 		TView;
							 var itsParams: 		Ptr);				
var
	itsArea:			Rect;
	numberOfPicts:		integer;		{ number of possible states for the control }
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mMultiPictHit;
	ControlArea (itsArea);
	with PictControlTPtr (itsParams)^ do begin
		numberOfPicts := (length (itsPictureIDs)) div 2;	{ 2 bytes per picture ID }
		CreateCMgrControl (itsArea, itsPictureIDs, 1, 1, numberOfPicts, kMultiPictProcID);
	end; {with}

	OffsetPtrWStr (itsParams, sizeof (PictControlTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TMultiPict.WRes		(theResource:	ViewRsrcHndl;
							 var itsParams:		Ptr); 				
var
	theLabel:		Str255;
	ptPtr:			PictControlTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	ptPtr := PictControlTPtr (ExpandPtrWStr (theResource, itsParams, 
									sizeof (PictControlTemplate), Length (theLabel)));
	CopyStr255 (theLabel, PRStr (ptPtr^.itsPictureIDs));
End; {WRes}

{$S WriteRes}
{----------}
Procedure TMultiPict.WriteRes		(theResource:	ViewRsrcHndl;
								 var itsParams:		Ptr); 				
Begin
	gWResSignature := kStdMultiPict; 
	gWResType := 'TMultiPict';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S ARes}
{----------}
Procedure TMultiPict.DoChoice	 (origView:		TView;
								 itsChoice:		integer);			
Begin
	if itsChoice = mMultiPictHit then begin
		Cycle (kRedraw);
	end;
	inherited DoChoice (origView, itsChoice);
End; {DoChoice}

{$S ARes}
{----------}
Procedure TMultiPict.Cycle		(redraw:		Boolean);
var
	curVal:		integer;
Begin
	curVal := GetVal;

	if curVal = GetMax then begin
		curVal := GetMin;
	end else begin
		curVal := curVal + 1;
	end;
	SetVal (curVal, redraw);
End; {Cycle}

{$S AFields}
{----------}
Procedure TMultiPict.Fields		(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);
Begin
	DoToField ('TMultiPict', nil, bClass);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TSlider (TCtlMgr)			Custom slider				}
{-------------------------------------------------------}

{$S AOpen}
{----------}
Procedure TSlider.ISlider	(itsSuperView:		TView;
							 itsLocation: 		VPoint; 
							 itsSize: 			VPoint;
							 itsHSizeDet: 		SizeDeterminer; 
							 itsVSizeDet: 		SizeDeterminer;
							 itsDirection:		VHSelect;
							 itsPicts: 			Str255;
							 itsProcID:			integer;
							 itsVal:			Longint;
							 itsMin:			Longint;
							 itsMax:			Longint);	
Begin
	ICtlMgr (itsSuperView, itsLocation, itsSize, 
					itsHSizeDet, itsVSizeDet, itsPicts,
					itsVal, itsMin, itsMax, itsProcID);
	fDirection := itsDirection;
	fDefChoice := mSliderHit;
End; {ISlider}

{$S AInit}
{----------}
Procedure TSlider.IRes 		(itsDocument:		TDocument;
							 itsSuperView:	 	TView;
						 var itsParams: 		Ptr);				
var
	itsArea:		Rect;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);
	
	fDefChoice := mSliderHit;
	ControlArea (itsArea);
	with SliderTPtr (itsParams)^ do begin
		CreateCMgrControl (itsArea, itsPictureIDs, 0, 0, 10, kSliderProcID + itsVariantCode);
	end; {with}

	with itsArea do begin
		if (bottom - top) >= (right - left) then begin
			fDirection := v;
		end else begin
			fDirection := h;
		end;
	end; {with}

	OffsetPtrWStr (itsParams, sizeof (SliderTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TSlider.WRes		(theResource:	ViewRsrcHndl;
						 var itsParams:		Ptr); 				
var
	theLabel:		Str255;
	stPtr:			SliderTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	GetText (theLabel);
	stPtr := SliderTPtr (ExpandPtrWStr (theResource, itsParams, 
									sizeof (SliderTemplate), Length (theLabel) + 2));
	stPtr^.itsVariantCode := 0;		{ should be control's variant code }
	CopyStr255 (theLabel, PRStr (stPtr^.itsPictureIDs));
End; {WRes}

{$S WriteRes}
{----------}
Procedure TSlider.WriteRes		(theResource:	ViewRsrcHndl;
							 var itsParams:		Ptr); 				
Begin
	gWResSignature := kStdSlider; 
	gWResType := 'TSlider';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S ARes}
{----------}
Procedure TSlider.DeltaValue	  (delta:			VCoordinate);
Begin
	if (delta <> 0) then begin
		if (delta > 0) then begin
			delta := Min (delta, fLongMax - fLongVal);
		end else begin
			delta := Max (delta, fLongMin - fLongVal);
		end;
		
		SetLongVal (fLongVal + delta, true);
	end;
End; {DeltaValue}

{$S ASelCommand}
{----------}
Function TSlider.DoMouseCommand 	(var theMouse:		Point;
									 var info:			EventInfo;
									 var hysteresis:	Point): TCommand;
var
	partCode:			integer;
	oldLongValue:		VCoordinate;
	newLongValue:		VCoordinate;
Begin
	{$IFC qDebug}
		AssumeFocused;
	{$ENDC}
	
	oldLongValue := fLongVal;
	partCode := TestControl (fCMgrControl, theMouse);
	
	case partCode of
		inUpButton,
		inDownButton, 
		inPageUp, 
		inPageDown:	begin
				partCode := TrackControl(fCMgrControl, theMouse, @ActionProcForTSlider);
				if fLongVal <> oldLongValue then begin
					DoChoice (self, fDefChoice);
				end;
			end;
		inThumb:	begin
				if TrackControl (fCMgrControl, theMouse, nil) = inThumb then begin
					if GetVal = GetMax then begin
						newLongValue := fLongMax;
					end else begin
						newLongValue := BSL (Longint(GetVal), fBitsToShift);
					end;
					SetLongVal(newLongValue, kRedraw);
				end;

				if fLongVal <> oldLongValue then begin
					DoChoice (self, fDefChoice);
				end;
			end;
	end; {case}
	
	DoMouseCommand := nil;
End; {DoMouseCommand}

{$S ARes}
{----------}
Procedure TSlider.TrackSlider		(partCode:		integer);
Begin
	DeltaValue (1);		{ only one part code }
End; {TrackSlider}

{$S ASelCommand}
{----------}
{ this is based on TScrollBar.ActionProc.  I'm not completely sure it's right }
Procedure TSlider.ActionProc		(partCode:		integer);
Begin
	if (partCode <> 0) then begin
		TrackSlider (partCode);		{ bounds checking? }
	end;
	Update;
	if Focus then begin
	end;
End; {ActionProc}

{$S AFields}
{----------}
Procedure TSlider.Fields	(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
							);
Begin
	DoToField ('TSlider', nil, bClass);
	DoToField ('fDirection', @fDirection, bVHSelect);
	inherited Fields (DoToField);
End; {Fields}

{-------------------------------------------------------}
{ TCustomCntl (TCtlMgr)			Other custom control	}
{-------------------------------------------------------}

Type
	CntlTemplate		= Record
		boundsRect:			Rect;
		value:				integer;
		visible:			Boolean;
		filler1:			Boolean;
		max:				integer;
		min:				integer;
		procID:				integer;
		refCon:				longint;
		title:				Str255;
	end;
	CntlTPtr			= ^CntlTemplate;
	CntlTHndl			= ^CntlTPtr;

{$S AOpen}
{----------}
Procedure TCustomCntl.ICustom 		(itsSuperView: 		TView;
									 itsLocation: 		VPoint; 
									 itsSize: 			VPoint;
									 itsHSizeDet: 		SizeDeterminer; 
									 itsVSizeDet: 		SizeDeterminer;
									 itsTitle:			Str255;
									 itsCntlID: 		integer);	
var
	itsCNTL:		Handle;
Begin
	fCntlID := itsCntlID;
	itsCNTL := Get1Resource ('CNTL', itsCntlID);
	LoadResource (itsCNTL);
	HLock (itsCNTL);
	with CntlTHndl (itsCNTL)^^ do begin;
		ICtlMgr (itsSuperView, itsLocation, itsSize, 
						 itsHSizeDet, itsVSizeDet, itsTitle, 
						 value, min, max, procID);
	end; {with}
	ReleaseResource (itsCNTL);
	fDefChoice := mCustomHit;
End; {ICustom}

{$S AInit}
{----------}
Procedure TCustomCntl.IRes 		(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr);
var
	itsArea:		Rect;
	itsCNTL:		Handle;
Begin
	inherited IRes (itsDocument, itsSuperView, itsParams);

	fDefChoice := mCustomHit;
	ControlArea (itsArea);
	with CustomControlTPtr (itsParams)^ do begin
		fCntlID := itsCntlID;
		itsCNTL := Get1Resource ('CNTL', itsCntlID);
		LoadResource (itsCNTL);
		HLock (itsCNTL);
		with CntlTHndl (itsCNTL)^^ do begin;
			CreateCMgrControl (itsArea, title, value, min, max, procID); 
		end; {with}
		ReleaseResource (itsCNTL);
	end; {with}

	OffsetPtr (itsParams, sizeof (CustomControlTemplate));
End; {IRes}

{$S WriteRes}
{----------}
Procedure TCustomCntl.WRes		  (theResource:		ViewRsrcHndl;
			   				   var itsParams:		Ptr); 
var
	ctPtr:		CustomControlTPtr;
Begin
	inherited WRes (theResource, itsParams);	
	
	ctPtr := CustomControlTPtr (ExpandPtr (theResource, itsParams, 
									sizeof (CustomControlTemplate)));
	ctPtr^.itsCntlID := fCntlID;
End; {WRes}

{$S WriteRes}
{----------}
Procedure TCustomCntl.WriteRes	  (theResource:		ViewRsrcHndl;
			  				   var itsParams:		Ptr);
Begin
	gWResSignature := kStdCustom; 
	gWResType := 'TCustomCntl';
	WRes (theResource, itsParams);
End; {WriteRes}

{$S AFields}
{----------}
Procedure TCustomCntl.Fields	(
				Procedure DoToField		(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
							);
Begin
	DoToField ('TCustomCntl', nil, bClass);
	DoToField ('fCntlID', @fCntlID, bInteger);
	inherited Fields (DoToField);
End; {Fields}

{End UAMLibrary.inc.p}
