{  1991, Bowers Development Corp. }
{ UAMLibraryM.p }

{===========================================================}
{ Classes to support AppMaker user interface items: 		}
{															}
{ Class			(Subclass)		Description					}
{-----------------------------------------------------------}
{ TGrayLine		(TView)			Gray line					}
{ TPalette		(TCtlMgr)		Palette						}
{ TPictButton	(TCtlMgr)		Picture button				}
{ TPictCheckBox (TCtlMgr)		Picture check box			}
{ TPictRadio 	(TCtlMgr)		Picture radio button		}
{ TMultiPict 	(TCtlMgr)		Multi-picture control		}
{ TSlider 		(TCtlMgr)		Custom slider				}
{ TCustomCntl 	(TCtlMgr)		Other custom control		}
{===========================================================}

Unit UAMLibraryM;
Interface

Uses
	UMacApp,
	Types,
	QuickDraw,
	Files,
	Resources;	

Const
	kPaletteProcID		=  		(200 * 16);			{ 3200 }

	kPictButtonProcID	=		(201 * 16);			{ 3216 }
	kPictCheckProcID	=		(201 * 16) + 1;		{ 3217 }	
	kPictRadioProcID	=		(201 * 16) + 2;		{ 3218 }	
	kMultiPictProcID	=		(201 * 16) + 3;		{ 3219 }	

	kSliderProcID			=   (202 * 16);
	kSliderGrayContinuousID	=	(202 * 16);			{ 3232 }
	kSliderIndContinuousID	=	(202 * 16) + 1;		{ 3233 }
	kSliderGrayDiscreteID	=	(202 * 16) + 2;		{ 3234 }
	kSliderIndDiscreteID 	=	(202 * 16) + 3;		{ 3235 }

	mMultiPictHit		= 101;
	mPaletteHit			= 102;
	mCustomHit			= 103;
	mSliderHit			= 104;

{----------}
Procedure ActionProcForTSlider	(aCMgrControl:	ControlHandle;
								 partCode:		integer);

{----------}
Type
	TGrayLine 			= Object (TView)
		Procedure Draw		(area:		Rect); Override;
	End; {TGrayLine}

Type
	PaletteTemplate		= Record
		itsPictureID:		integer;
		itsNumberAcross:	integer;
		itsNumberDown:		integer;
		itsFrameSize:		integer;
	End;
	PaletteTPtr			= ^PaletteTemplate;
	
Type
	TPalette			= Object (TCtlMgr)
		Procedure IPalette		(itsSuperView: 		TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet: 		SizeDeterminer; 
								 itsVSizeDet: 		SizeDeterminer;
								 itsPictureID:		integer;
								 itsNumberAcross:	integer;
								 itsNumberDown:		integer;
								 itsFrameSize:		integer);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView: 		TView;
							 var itsParams: 		Ptr); 			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TPalette}

Type
	PictControlTemplate		= Record
		itsPictureIDs:			Str255;
	End;
	PictControlTPtr			= ^PictControlTemplate;

Type
	TPictButton 		= Object (TCtlMgr)
		Procedure IPictButton	(itsSuperView:		TView;
								 itsLocation:		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet:		SizeDeterminer; 
								 itsVSizeDet:		SizeDeterminer;
								 itsPicts:			Str255);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:		TView;
							 var itsParams: 		Ptr); 			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TPictButton}

Type
	TPictCheckBox 		= Object (TCtlMgr)
		Procedure IPictCheckBox	(itsSuperView:	 	TView;
								 itsLocation:	 	VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet:	 	SizeDeterminer; 
								 itsVSizeDet:	 	SizeDeterminer;
								 itsPicts:			Str255;
								 isTurnedOn:	 	Boolean);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr);			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure DoChoice		(origView:			TView;
								 itsChoice:			integer);		Override;
		Function  IsOn: Boolean;
		Procedure SetState		(state:				Boolean;
								 redraw:			Boolean);
		Procedure Toggle		(redraw:			Boolean);
		Procedure ToggleIf		(matchState:		Boolean;
								 redraw:			Boolean);
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TPictCheckBox}

Type
	TPictRadio 			= Object (TCtlMgr)
		Procedure IPictRadio	(itsSuperView: 		TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet: 		SizeDeterminer; 
								 itsVSizeDet:	 	SizeDeterminer;
								 itsPicts:			Str255;
								 isTurnedOn:		Boolean);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr); 			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure DoChoice		(origView:			TView;
								 itsChoice:			integer);		Override;
		Function  IsOn: Boolean;
		Procedure SetState		(state:				Boolean;
								 redraw:			Boolean);
		Procedure Toggle		(redraw:			Boolean);
		Procedure ToggleIf		(matchState:		Boolean;
								 redraw:			Boolean);
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TPictRadio}

Type
	TMultiPict 			= Object (TCtlMgr)
		Procedure IMultiPict	(itsSuperView:	 	TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet: 		SizeDeterminer; 
								 itsVSizeDet:	 	SizeDeterminer;
								 itsPicts: 			Str255;
								 curValue:			integer);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr);			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure DoChoice		(origView:			TView;
								 itsChoice:			integer);		Override;
		Procedure Cycle			(redraw:			Boolean);
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TMultiPict}

Type
	SliderTemplate		= Record
		itsVariantCode:		integer;
		itsPictureIDs:		Str255;
	End;
	SliderTPtr	 		= ^SliderTemplate;
	
Type
	TSlider 			= Object (TCtlMgr)
		fDirection:			VHSelect;	{ horizontal or vertical }

		Procedure ISlider		(itsSuperView:	 	TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet: 		SizeDeterminer; 
								 itsVSizeDet: 		SizeDeterminer;
								 itsDirection:		VHSelect;
								 itsPicts: 			Str255;
								 itsProcID:			integer;
								 itsVal:			Longint;
								 itsMin:			Longint;
								 itsMax:			Longint);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr); 				Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 				Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 				Override;
		Procedure DeltaValue	(delta:				VCoordinate);
		Function DoMouseCommand (var theMouse:		Point;
								 var info:			EventInfo;
								 var hysteresis:	Point): TCommand;	Override;
		Procedure TrackSlider	(partCode:			integer);
		Procedure ActionProc	(partCode:			integer);
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TSlider}

Type
	CustomControlTemplate	= Record
		itsCntlID:				integer;
	End;
	CustomControlTPtr		= ^CustomControlTemplate;
	
Type
	TCustomCntl 			= Object (TCtlMgr)
		fCntlID:			integer;

		Procedure ICustom		(itsSuperView:	 	TView;
								 itsLocation: 		VPoint; 
								 itsSize: 			VPoint;
								 itsHSizeDet:	 	SizeDeterminer; 
								 itsVSizeDet:	 	SizeDeterminer;
								 itsTitle:			Str255;
								 itsCntlID: 		integer);	
		Procedure IRes 			(itsDocument:		TDocument;
								 itsSuperView:	 	TView;
							 var itsParams: 		Ptr); 			Override;
		Procedure WRes			(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure WriteRes		(theResource:		ViewRsrcHndl;
							 var itsParams:			Ptr); 			Override;
		Procedure Fields		(
					Procedure DoToField	(fieldName:		Str255;
										 fieldAddr:		Ptr;
										 fieldType:		integer)
								);	 Override;
	End; {TCustomCntl}

{----------}
Implementation

{$I UAMLibraryM.inc.p}

End. {UAMLibraryM.p}
